require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PCTRIE_H_)) {
    eval 'sub _SYS_PCTRIE_H_ () {1;}' unless defined(&_SYS_PCTRIE_H_);
    require 'sys/_pctrie.ph';
    require 'sys/_smr.ph';
    if(defined(&_KERNEL)) {
	eval 'sub PCTRIE_DEFINE_SMR {
	    my($name, $type, $field, $allocfn, $freefn, $smr) = @_;
    	    eval q( &PCTRIE_DEFINE($name, $type, $field, $allocfn, $freefn)  &static  &__inline \'struct type\' * $name &_PCTRIE_LOOKUP_UNLOCKED(\'struct pctrie\' * &ptree,  &uint64_t  &key) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_lookup_unlocked( &ptree,  &key, ($smr))); });
	}' unless defined(&PCTRIE_DEFINE_SMR);
	if(defined(&INVARIANTS)) {
	} else {
	    eval 'sub pctrie_subtree_lookup_gt_assert {
	        my($node, $key, $ptree, $res) = @_;
    		eval q();
	    }' unless defined(&pctrie_subtree_lookup_gt_assert);
	    eval 'sub pctrie_subtree_lookup_lt_assert {
	        my($node, $key, $ptree, $res) = @_;
    		eval q();
	    }' unless defined(&pctrie_subtree_lookup_lt_assert);
	}
	eval 'sub PCTRIE_DEFINE {
	    my($name, $type, $field, $allocfn, $freefn) = @_;
    	    eval q( &CTASSERT($sizeof{(0)->$field} == $sizeof{ &uint64_t});  &CTASSERT(( &__offsetof(\'struct type\', $field) & ($sizeof{ &uint32_t} - 1)) == 0);  &static  &__inline \'struct type\' * $name &_PCTRIE_VAL2PTR( &uint64_t * &val) {  &if ( &val ==  &NULL)  &return ( &NULL);  &return  (( &uintptr_t) &val -  &__offsetof(\'struct type\', $field)); }  &static  &__inline  &uint64_t * $name &_PCTRIE_PTR2VAL(\'struct type\' * &ptr) {  &return  ($ptr->{field}); }  &static  &__inline  &__unused \'int\' $name &_PCTRIE_INSERT_BASE(\'struct pctrie\' * &ptree,  &void * &parentp,  &uint64_t * &val,  &uint64_t * &found, \'struct type\' ** &found_out) { \'struct pctrie_node\' * &parent;  &if ( &__predict_false( &found !=  &NULL)) { * &found_out = $name &_PCTRIE_VAL2PTR( &found);  &return ( &EEXIST); }  &if ( &parentp !=  &NULL) {  &parent = $allocfn( &ptree);  &if ( &__predict_false( &parent ==  &NULL)) {  &if ( &found_out !=  &NULL) * &found_out =  &NULL;  &return ( &ENOMEM); }  &pctrie_insert_node( &parentp,  &parent,  &val); }  &return (0); }  &static  &__inline  &__unused \'int\' $name &_PCTRIE_INSERT(\'struct pctrie\' * &ptree, \'struct type\' * &ptr) {  &void * &parentp;  &uint64_t * &val = $name &_PCTRIE_PTR2VAL( &ptr);  &parentp =  &pctrie_insert_lookup_strict( &ptree,  &val);  &return ($name &_PCTRIE_INSERT_BASE( &ptree,  &parentp,  &val,  &NULL,  &NULL)); }  &static  &__inline  &__unused \'int\' $name &_PCTRIE_FIND_OR_INSERT(\'struct pctrie\' * &ptree, \'struct type\' * &ptr, \'struct type\' ** &found_out_opt) {  &void * &parentp;  &uint64_t * &val = $name &_PCTRIE_PTR2VAL( &ptr);  &uint64_t * &found;  &parentp =  &pctrie_insert_lookup( &ptree,  &val,  &found);  &return ($name &_PCTRIE_INSERT_BASE( &ptree,  &parentp,  &val,  &found,  &found_out_opt)); }  &static  &__inline  &__unused \'int\' $name &_PCTRIE_INSERT_LOOKUP_GE(\'struct pctrie\' * &ptree, \'struct type\' * &ptr, \'struct type\' ** &found_out) { \'struct pctrie_node\' * &neighbor;  &void * &parentp;  &uint64_t * &val = $name &_PCTRIE_PTR2VAL( &ptr);  &uint64_t * &found; \'int\'  &retval;  &parentp =  &pctrie_insert_lookup_gt( &ptree,  &val,  &found,  &neighbor);  &retval = $name &_PCTRIE_INSERT_BASE( &ptree,  &parentp,  &val,  &found,  &found_out);  &if ( &retval != 0)  &return ( &retval);  &found =  &pctrie_subtree_lookup_gt( &neighbor, * &val); * &found_out = $name &_PCTRIE_VAL2PTR( &found);  &pctrie_subtree_lookup_gt_assert( &neighbor, * &val,  &ptree,  &found);  &return (0); }  &static  &__inline  &__unused \'int\' $name &_PCTRIE_INSERT_LOOKUP_LE(\'struct pctrie\' * &ptree, \'struct type\' * &ptr, \'struct type\' ** &found_out) { \'struct pctrie_node\' * &neighbor;  &void * &parentp;  &uint64_t * &val = $name &_PCTRIE_PTR2VAL( &ptr);  &uint64_t * &found; \'int\'  &retval;  &parentp =  &pctrie_insert_lookup_lt( &ptree,  &val,  &found,  &neighbor);  &retval = $name &_PCTRIE_INSERT_BASE( &ptree,  &parentp,  &val,  &found,  &found_out);  &if ( &retval != 0)  &return ( &retval);  &found =  &pctrie_subtree_lookup_lt( &neighbor, * &val); * &found_out = $name &_PCTRIE_VAL2PTR( &found);  &pctrie_subtree_lookup_lt_assert( &neighbor, * &val,  &ptree,  &found);  &return (0); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_LOOKUP(\'struct pctrie\' * &ptree,  &uint64_t  &key) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_lookup( &ptree,  &key)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_LOOKUP_LE(\'struct pctrie\' * &ptree,  &uint64_t  &key) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_lookup_le( &ptree,  &key)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_LOOKUP_GE(\'struct pctrie\' * &ptree,  &uint64_t  &key) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_lookup_ge( &ptree,  &key)); }  &static  &__inline  &__unused  &void $name &_PCTRIE_RECLAIM(\'struct pctrie\' * &ptree) { \'struct pctrie_node\' * &freenode, * &node;  &for ( &freenode =  &pctrie_reclaim_begin( &node,  &ptree);  &freenode !=  &NULL;  &freenode =  &pctrie_reclaim_resume( &node)) $freefn( &ptree,  &freenode); }  &static  &__inline  &__unused  &void $name &_PCTRIE_RECLAIM_CALLBACK(\'struct pctrie\' * &ptree,  &void (* &typed_cb)(\'struct type\' *,  &void *),  &void * &arg) { \'struct pctrie_node\' * &freenode, * &node;  &pctrie_cb_t  &callback = ( &pctrie_cb_t) &typed_cb;  &for ( &freenode =  &pctrie_reclaim_begin_cb( &node,  &ptree,  &callback,  &__offsetof(\'struct type\', $field),  &arg);  &freenode !=  &NULL;  &freenode =  &pctrie_reclaim_resume_cb( &node,  &callback,  &__offsetof(\'struct type\', $field),  &arg)) $freefn( &ptree,  &freenode); }  &static  &__inline  &__unused \'int\' $name &_PCTRIE_ITER_INSERT(\'struct pctrie_iter\' * &it, \'struct type\' * &ptr) { \'struct pctrie_node\' * &parent;  &void * &parentp;  &uint64_t * &val = $name &_PCTRIE_PTR2VAL( &ptr);  &parentp =  &pctrie_iter_insert_lookup( &it,  &val);  &if ( &parentp ==  &NULL)  &return (0);  &parent = $allocfn( ($it->{ptree}));  &if ( &__predict_false( &parent ==  &NULL))  &return ( &ENOMEM);  &pctrie_insert_node( &parentp,  &parent,  &val);  ($it->{path[&it}->{top++]}) =  &parent;  &return (0); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_LOOKUP(\'struct pctrie_iter\' * &it,  &uint64_t  &index) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_lookup( &it,  &index)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_STRIDE(\'struct pctrie_iter\' * &it, \'int\'  &stride) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_stride( &it,  &stride)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_NEXT(\'struct pctrie_iter\' * &it) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_next( &it)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_PREV(\'struct pctrie_iter\' * &it) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_prev( &it)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_VALUE(\'struct pctrie_iter\' * &it) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_value( &it)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_LOOKUP_GE(\'struct pctrie_iter\' * &it,  &uint64_t  &index) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_lookup_ge( &it,  &index)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_JUMP_GE(\'struct pctrie_iter\' * &it,  &int64_t  &jump) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_jump_ge( &it,  &jump)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_STEP_GE(\'struct pctrie_iter\' * &it) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_jump_ge( &it, 1)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_LOOKUP_LE(\'struct pctrie_iter\' * &it,  &uint64_t  &index) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_lookup_le( &it,  &index)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_JUMP_LE(\'struct pctrie_iter\' * &it,  &int64_t  &jump) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_jump_le( &it,  &jump)); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_ITER_STEP_LE(\'struct pctrie_iter\' * &it) {  &return $name &_PCTRIE_VAL2PTR( &pctrie_iter_jump_le( &it, 1)); }  &static  &__inline  &__unused  &void $name &_PCTRIE_REMOVE_BASE(\'struct pctrie\' * &ptree, \'struct pctrie_node\' * &freenode) {  &if ( &freenode !=  &NULL) $freefn( &ptree,  &freenode); }  &static  &__inline  &__unused  &void $name &_PCTRIE_ITER_REMOVE(\'struct pctrie_iter\' * &it) {  &uint64_t * &val; \'struct pctrie_node\' * &freenode;  &val =  &pctrie_iter_remove( &it,  &freenode);  &if ( &val ==  &NULL)  &panic(\\"%s: key not found\\",  &__func__); $name &_PCTRIE_REMOVE_BASE( ($it->{ptree}),  &freenode); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_REPLACE(\'struct pctrie\' * &ptree, \'struct type\' * &ptr) {  &return $name &_PCTRIE_VAL2PTR(  &pctrie_replace( &ptree, $name &_PCTRIE_PTR2VAL( &ptr))); }  &static  &__inline  &__unused  &void $name &_PCTRIE_REMOVE(\'struct pctrie\' * &ptree,  &uint64_t  &key) {  &uint64_t * &val; \'struct pctrie_node\' * &freenode;  &val =  &pctrie_remove_lookup( &ptree,  &key,  &freenode);  &if ( &val ==  &NULL)  &panic(\\"%s: key not found\\",  &__func__); $name &_PCTRIE_REMOVE_BASE( &ptree,  &freenode); }  &static  &__inline  &__unused \'struct type\' * $name &_PCTRIE_REMOVE_LOOKUP(\'struct pctrie\' * &ptree,  &uint64_t  &key) {  &uint64_t * &val; \'struct pctrie_node\' * &freenode;  &val =  &pctrie_remove_lookup( &ptree,  &key,  &freenode); $name &_PCTRIE_REMOVE_BASE( &ptree,  &freenode);  &return $name &_PCTRIE_VAL2PTR( &val); });
	}' unless defined(&PCTRIE_DEFINE);
	eval 'sub PCTRIE_ISLEAF () {0x1;}' unless defined(&PCTRIE_ISLEAF);
	eval 'sub PCTRIE_NULL () { &PCTRIE_ISLEAF;}' unless defined(&PCTRIE_NULL);
	eval 'sub pctrie_init {
	    my($ptree) = @_;
    	    eval q({  ($ptree->{pt_root}) =  &PCTRIE_NULL; });
	}' unless defined(&pctrie_init);
	eval 'sub pctrie_is_empty {
	    my($ptree) = @_;
    	    eval q({ ( ($ptree->{pt_root}) ==  &PCTRIE_NULL); });
	}' unless defined(&pctrie_is_empty);
	eval 'sub PCTRIE_FLAGS () {( &PCTRIE_ISLEAF);}' unless defined(&PCTRIE_FLAGS);
	eval 'sub PCTRIE_PAD () { &PCTRIE_FLAGS;}' unless defined(&PCTRIE_PAD);
	if(defined(&__LP64__)) {
	    eval 'sub PCTRIE_WIDTH () {4;}' unless defined(&PCTRIE_WIDTH);
	} else {
	    eval 'sub PCTRIE_WIDTH () {3;}' unless defined(&PCTRIE_WIDTH);
	}
	eval 'sub PCTRIE_COUNT () {(1<<  &PCTRIE_WIDTH);}' unless defined(&PCTRIE_COUNT);
	eval 'sub PCTRIE_LIMIT () { &howmany($sizeof{ &uint64_t} *  &NBBY,  &PCTRIE_WIDTH);}' unless defined(&PCTRIE_LIMIT);
	eval 'sub pctrie_iter_reset {
	    my($it) = @_;
    	    eval q({  ($it->{top}) = 0; });
	}' unless defined(&pctrie_iter_reset);
	eval 'sub pctrie_iter_init {
	    my($it,$ptree) = @_;
    	    eval q({  ($it->{ptree}) = $ptree;  ($it->{top}) = 0;  ($it->{limit}) = 0; });
	}' unless defined(&pctrie_iter_init);
	eval 'sub pctrie_iter_limit_init {
	    my($it,$ptree,$limit) = @_;
    	    eval q({  &pctrie_iter_init($it, $ptree);  ($it->{limit}) = $limit; });
	}' unless defined(&pctrie_iter_limit_init);
    }
}
1;
